SystemOrganization addCategory: #'Mercury-Ide'!

PluggableListItemWrapper subclass: #MercuryTreeItem
	instanceVariableNames: 'icon contents info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryTreeItem class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:55'!
newFromAssociation: anAssociation withIcon: anIcon

	^ self new
		item: anAssociation key;
		contents: anAssociation value;
		withIcon: anIcon.! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:57'!
contents

	^ contents! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:57'!
contents: aCollectionOfTreeItems

	contents := aCollectionOfTreeItems ! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 14:24'!
icon

	^ icon! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:57'!
item

	^ item! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:58'!
item: aString 

	item := aString! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 11:20'!
metaInfo

	^ info! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 11:20'!
metaInfo: anObject 

	info := anObject! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 13:57'!
withIcon: aForm 
	icon := aForm! !

TabGroupMorph subclass: #MercuryTabGroupMorph
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2013 14:12'!
onTabChanged: aCallback 

	callback := aCallback ! !

!MercuryTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2013 14:08'!
updatePageIndex: index

	super updatePageIndex: index.
	callback ifNotNil: [callback value: index]! !

Object subclass: #MercuryIDE
	instanceVariableNames: 'window environmentMirrors tabGroup tab lastTarget lastAlias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/28/2012 14:19'!
buildRowWithImage: anImageFilename andLabel: labelText

	 ^ window newRow: {
		window newImage: (Form fromFileNamed: self resourcesDirectory , anImageFilename).
		(window newLabel: labelText)
	}! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/17/2013 16:02'!
buildUI
	
	| tabTopMorph panelTarget panelAlias openButton |
	
	panelTarget := window newPanel
		layoutPolicy: RowLayout new;
		addMorph: ((window newTextEntryFor: self 
			getText:  #getTarget
			setText: #setTarget help: '')
			hResizing: #spaceFill; 
			acceptAction: [:source | self openTarget: source]
			yourself);
		addMorph: ((self buildRowWithImage: 'debug.png' andLabel: 'Add Debugging Target: ' ) hResizing: #shrinkWrap).
		
	panelAlias := window newPanel
		layoutPolicy: RowLayout new;
		addMorph: ((window newTextEntryFor: self 
			getText:  #getAlias 
			setText: #setAlias help: '')
			hResizing: #spaceFill; 
			acceptAction: [:source | self openTarget: source]
			yourself);
		addMorph: ((self buildRowWithImage: 'environment.png' andLabel: 'Target Alias: ' ) hResizing: #shrinkWrap).
		
	openButton := (window newButtonFor: self  action: #openNewTarget label: (window newImage: (Form fromFileNamed: self resourcesDirectory , 'browse.png')) help: 'Open').
	
	tabTopMorph := StandardWindow new
		beWithoutGrips;
		removeLabelArea;
		makeBorderless;
		addMorph: panelTarget frame:  (0.25@0.35 corner: 0.75@0.45);
		addMorph: panelAlias frame: (0.25@0.46 corner: 0.75@0.56);
		addMorph:  openButton frame: (0.25@0.57 corner: 0.75@0.67).
		
	tabGroup  
		addPage: tabTopMorph 
		label: (window newImage: (Form fromFileNamed: self resourcesDirectory , 'add.png')).
	
	tabGroup page: tabTopMorph.
	
	window title: '-:~#Alexandria#~:-';
		openInWorld; 
		fullscreen.
	self showLogo.! !

!MercuryIDE methodsFor: 'resources' stamp: 'NickPapoulias 9/17/2013 11:14'!
fullFrame: relFrame

	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
		
	^ frame! !

!MercuryIDE methodsFor: 'target-alias' stamp: 'NickPapoulias 9/17/2013 15:56'!
getAlias

	^ lastAlias! !

!MercuryIDE methodsFor: 'target-alias' stamp: 'NickPapoulias 9/17/2013 15:55'!
getTarget

	^ lastTarget! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/17/2013 10:45'!
initialize 

	window := StandardWindow new.
	
	tabGroup := TabGroupMorph new.  
		
	window addMorph: tabGroup frame: (0@0 corner: 1@1).
	
	tabGroup color: window color.

	environmentMirrors := OrderedCollection new.
	
	self buildUI.! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/14/2013 16:23'!
logging: aBoolean

	SeamlessDeamonManager default logging: aBoolean.
	(SeamlessDeamonManager from: '127.0.0.1:8081') default logging: aBoolean.
	! !

!MercuryIDE methodsFor: 'resources' stamp: 'NickPapoulias 9/16/2013 17:09'!
newTabWith: anEnvironementMirror 

	| environmentTab tabTopMorph |
	environmentTab := MercuryIdeEnvironmentTab new.
	environmentMirrors add: anEnvironementMirror.
	tabTopMorph := (environmentTab openWithEnvironmentMirror: (environmentMirrors last)). 
	tabGroup 
		addPage: tabTopMorph 
		label: (self buildRowWithImage: 'environment.png' andLabel: environmentMirrors last localHostName).
	tabGroup page: tabTopMorph.
	environmentMirrors size = 1 ifTrue: [environmentTab showLogo].	! !

!MercuryIDE methodsFor: 'resources' stamp: 'NickPapoulias 9/17/2013 12:01'!
openTarget: anAddress

	self openWithEnvironmentMirror: (Reflection on: (RemoteEnvironment @ anAddress))! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/17/2013 10:45'!
openWithEnvironmentMirror: anEnvironementMirror
	
	self newTabWith: anEnvironementMirror.
	! !

!MercuryIDE methodsFor: 'resources' stamp: 'NickPapoulias 6/19/2013 11:13'!
resourcesDirectory

	^ PlatformResolver forCurrentPlatform home parent parent asString , '/MercuryIDE_resources/'! !

!MercuryIDE methodsFor: 'target-alias' stamp: 'NickPapoulias 9/17/2013 15:56'!
setAlias: aString

	lastAlias := aString! !

!MercuryIDE methodsFor: 'target-alias' stamp: 'NickPapoulias 9/17/2013 15:55'!
setTarget: aString

	lastTarget := aString! !

!MercuryIDE methodsFor: 'resources' stamp: 'NickPapoulias 9/17/2013 10:56'!
showLogo

	| logo displayPoint |
	logo := (Form fromFileNamed: self resourcesDirectory , 'alexandria-logo.png').
	displayPoint := Point
					x: Display center x - (logo width / 2) asInteger
					y: Display center y - (logo height / 2) asInteger.
	[(Delay forSeconds: 1) wait.
	logo displayOn: Display at: displayPoint.
	(Delay forSeconds: 5) wait.
	Display restore.] fork.! !

Object subclass: #MercuryIdeEnvironmentTab
	instanceVariableNames: 'morphs layout environmentMirror unhandledExceptions uiModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/12/2013 15:00'!
acceptSource: sourceCode

	|resultMirror selector|
	
	self inDebugView & self inDebugMode ifTrue: [
		^ self recompileCurrentMethodTo: sourceCode.
	].

	self acceptSourceForBrowser: sourceCode.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/12/2013 15:00'!
acceptSourceForBrowser: sourceCode

	|resultMirror selector|
	
	self inMetaView ifTrue: [^ self acceptSourceForMeta: sourceCode ].
	
	selector := nil.
	resultMirror := nil.

	(uiModel at: #selectedProtocol) ifNotNil: [
		selector := self compileMethodWithSource: sourceCode asString inClassNamed: (uiModel at: #selectedClass) item.
	] ifNil: [
		(uiModel at: #selectedClass) ifNotNil: [
			resultMirror := self evaluateSourceCode: sourceCode asString.
		]
	].

	selector ifNotNil: [
	
			|selectedMethod|
			
			self changed: #methodsHierarchy.
			selectedMethod := ((uiModel at: #methods) select: [:methodItem | methodItem item = selector asString]) first.
			self selectedMethod: selectedMethod.
			
	] ifNil: [
			resultMirror ifNotNil: [
				(resultMirror isKindOf: ClassIntrospectionMirror) ifTrue: [
				
					|selectedClass className|
				
					self changed: #classHierarchy.
					resultMirror isMeta ifTrue: [
						className := resultMirror soleInstance systemName asString.
					] ifFalse: [
						className := resultMirror systemName asString.
					].
					selectedClass := ((uiModel at: #classes) select: [:classItem | classItem item = className]) first.
					self selectedClass: selectedClass.				
				].
			].
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/11/2013 15:02'!
acceptSourceForMeta: sourceCode

	|resultMirror selector|
		
	selector := nil.
	resultMirror := nil.

	(uiModel at: #selectedProtocol) ifNotNil: [
		selector := self compileMethodWithSource: sourceCode asString inMetaClassNamed: (uiModel at: #selectedClass) item.
	] ifNil: [
		(uiModel at: #selectedClass) ifNotNil: [
			resultMirror := self evaluateSourceCode: sourceCode asString.
		]
	].

	selector ifNotNil: [
	
			|selectedMethod|
			
			self changed: #methodsHierarchy.
			selectedMethod := ((uiModel at: #methods) select: [:methodItem | methodItem item = selector asString]) first.
			self selectedMethod: selectedMethod.
			
	] ifNil: [
			resultMirror ifNotNil: [
				(resultMirror isKindOf: ClassIntrospectionMirror) ifTrue: [
				
					|selectedClass className|
				
					self changed: #classHierarchy.
					resultMirror isMeta ifTrue: [
						className := resultMirror soleInstance systemName asString.
					] ifFalse: [
						className := resultMirror systemName asString.
					].
					selectedClass := ((uiModel at: #classes) select: [:classItem | classItem item = className]) first.
					self selectedClass: selectedClass.				
				].
			].
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:47'!
allClassNamesForPackage: aPackageName

	^ (environmentMirror packageNamed: aPackageName) classes! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/11/2013 15:28'!
allMethodNamesForProtocol: aProtocolName inClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) methodsInProtocol: aProtocolName ! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/11/2013 15:29'!
allMethodNamesForProtocol: aProtocolName inMetaClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) objClass methodsInProtocol: aProtocolName ! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 12:12'!
allMethodNamesInClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) methodNames! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/11/2013 15:24'!
allMethodNamesInMetaClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) objClass methodNames! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:45'!
allPackageNames

	^ environmentMirror packageNames! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 6/21/2012 13:13'!
allProcesses

	^ #()! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:54'!
allProtocolNamesForClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) protocols.
	
	! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/11/2013 12:16'!
allProtocolNamesForMetaClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) objClass protocols.
	
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-protocols' stamp: 'NickPapoulias 6/20/2012 12:51'!
allProtocols

	^ #(accessing initialize)




	! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 8/20/2013 15:43'!
allTestMethodNamesForClass: aClassName

	|tClass|

	tClass := (environmentMirror globalAt: aClassName) testClass.
	tClass ifNil: [^ nil] ifNotNil: [
		^ tClass methodNames select: [:name | name asString includesSubString: 'test'].	
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/20/2013 16:29'!
allTestsForClass

	| testMethodNames |
	
	(uiModel at: #selectedClass) ifNil: [ ^ uiModel at: #testMethods put: #() ].
	
	testMethodNames := (self allTestMethodNamesForClass: (uiModel at: #selectedClass) item).

	testMethodNames ifNil: [ ^ uiModel at: #testMethods put: #() ].

	uiModel at: #testMethods put:  ((testMethodNames) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'test.png')) metaInfo: {} asDictionary	
	 ]).

	^ uiModel at: #testMethods.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 4/11/2013 14:32'!
baseMetaSwitch

	self changed: #selectedClass.
	self changed: #protocolsHierarchy.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-classes' stamp: 'NickPapoulias 8/22/2013 14:38'!
buildClassesMorph

	morphs at: #classesListingMorph put: ((morphs at: #window) newTreeFor: self
				list: #classHierarchy
				selected: #selectedClass
				changeSelected: #selectedClass:).
				
	morphs at: #metaTabMorph put: (self buildRowWithImage: 'class.png' andLabel: 'Meta') -> (morphs at: #classesListingMorph). 

	morphs at: #classesMorph put: (self newTabGroupIn: (morphs at: #window) 
										for:  {
											(self buildRowWithImage: 'class.png' andLabel: 'Classes') -> (morphs at: #classesListingMorph).
											morphs at: #metaTabMorph.										
										}  
										onTabChanged: [:index | self baseMetaSwitch ]).
										
	morphs 
		at: #classesMorph 
		put: ((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph: 	(self buildControlButtons: {
					'Add' -> #classAdd. "in selectors check if it is base/meta"
					'Edit' -> #classEdit.
					'Remove' -> #classRemove.
				} asOrderedCollection);
				addMorph: (morphs at: #classesMorph)).


	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-console' stamp: 'NickPapoulias 7/13/2012 11:23'!
buildContextConsoleMorph

		
		morphs at: #console put: (((morphs at: #window) newTextEditorFor: self  getText: #consoleText  setText: #consoleText:) acceptOnCR: true;
	acceptAction: [:contents | self consoleAccept: contents]). 

          morphs at: #consoleMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'console.png' andLabel: 'Context Console') -> (morphs at: #console)
		}).

	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-context-inspector' stamp: 'NickPapoulias 8/25/2013 14:19'!
buildContextInspectorMorph


		morphs at: #cInspectorMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'data.png' andLabel: 'Context Inspector') ->
				((morphs at: #window) newPanel
					layoutPolicy: RowLayout new;
					addMorph: ((morphs at: #window) newListFor: self list: #ctxVarValues selected: nil  changeSelected: nil  help: nil);
					addMorph: ((morphs at: #window) newListFor: self list: #ctxVarNames selected: #selectedCtxVar changeSelected: #selectedCtxVar:  help: nil)
					
				).

		}).
		
		morphs 
		at: #cInspectorMorph
		put: ((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph: 	(self buildControlButtons: {
					'Browse' -> #ctxBrowse.
					'Edit' -> #ctxEdit.
					'Instrument' -> #ctxInstr.
				} asOrderedCollection);
				addMorph: (morphs at: #cInspectorMorph)).
! !

!MercuryIdeEnvironmentTab methodsFor: 'utilities' stamp: 'NickPapoulias 8/22/2013 12:56'!
buildControlButtons: labelToActionAssocCollection

	"the label name is also used for the Image displayed"
	
	|row|
	
	row := (morphs at: #window) newRow.
	
	labelToActionAssocCollection reverse do: [ :assoc |
	
		row addMorph: ((morphs at: #window) 
										newButtonFor: self 
										action: assoc value
										label: (self buildRowWithImage: assoc key asString asLowercase , '.png' andLabel: assoc key asString )
										help: '')
			fullFrame: nil.
		
	].
	
	^ row! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-debug' stamp: 'NickPapoulias 4/23/2013 12:43'!
buildDebugMorph

          morphs at: #debugMorph put: (((morphs at: #window) newPanel) 
				layoutPolicy: RowLayout new;
				addMorph: (((morphs at: #window) newTextEntryFor: self getText:  nil setText: #runDebug: help: '')hResizing: #spaceFill;yourself);
				addMorph: ((self buildRowWithImage: 'debug.png' andLabel: 'Run/Debug: ' ) hResizing: #shrinkWrap);
				addMorph: ((morphs at: #window) newButtonFor: self  action: #through label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'through.png')) help: 'Through');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #over label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'fast_forward.png')) help: 'Over');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #into label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'forward.png')) help: 'Into');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #stopSelectedProcess label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'stop.png')) help: 'Abandon');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #interuptSelectedProcess label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'pause.png')) help: 'Interrupt');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #proceed label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'play.png')) help: 'Proceed');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #restart label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'restart.png')) help: 'Restart');
				addMorph: ((self buildRowWithImage: 'debug.png' andLabel: 'Debug: ' ) hResizing: #shrinkWrap)).! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 7/2/2012 10:29'!
buildEnvironmentMorph

	morphs at: #environmentMorph put:  ((morphs at: #window) newTabGroup: { self buildPackagesMorph. self buildProcessMorph. self buildExceptionsMorph}).! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-exceptions' stamp: 'NickPapoulias 4/9/2013 15:29'!
buildExceptionsMorph

	morphs at: #exceptionsMorph put: ((self buildRowWithImage: 'exception.png' andLabel: 'Exceptions' )
		->
			((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph:
						((morphs at: #window)
								newTabGroup:
									{('Stack'
										->
											((morphs at: #window)
												newTreeFor: self
												list: #stack
												selected: #selectedContext
												changeSelected: #selectedContext:
											))});
				addMorph:
						((morphs at: #window)
								newTreeFor: self
								list: #exceptions
								selected: #selectedException
								changeSelected: #selectedException:
						))).
						
		^ morphs at: #exceptionsMorph.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-methods' stamp: 'NickPapoulias 8/22/2013 14:47'!
buildMethodsMorph

          morphs at: #methodsMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'method.png' andLabel: 'Methods') ->
				((morphs at: #window) newTreeFor: self
				list: #methodsHierarchy
				selected: #selectedMethod
				changeSelected: #selectedMethod:).
		}).
		
		
		morphs 
		at: #methodsMorph 
		put: ((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph: 	(self buildControlButtons: {
					'Add' -> #methodAdd.
					'Edit' -> #methodEdit.
					'Remove' -> #methodRemove.
				} asOrderedCollection);
				addMorph: (morphs at: #methodsMorph)).


	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-object-inspector' stamp: 'NickPapoulias 8/25/2013 14:19'!
buildObjInspectorMorph 

	morphs at: #sInspectorMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'data_fields.png' andLabel: 'Object Inspector') ->
				((morphs at: #window) newPanel
					layoutPolicy: RowLayout new;
					addMorph: ((morphs at: #window) newListFor: self list: #objInstVarValues selected: nil  changeSelected: nil  help: nil);
					addMorph: ((morphs at: #window) newListFor: self list: #objInstVarNames selected: #selectedObjVar  changeSelected: #selectedObjVar:  help: nil)
					
				).
		}).
		
	morphs 
		at: #sInspectorMorph
		put: ((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph: 	(self buildControlButtons: {
					'Browse' -> #objBrowse.
					'Edit' -> #objEdit.
					'Instrument' -> #objInstr.
				} asOrderedCollection);
				addMorph: (morphs at: #sInspectorMorph)).
! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 8/22/2013 12:09'!
buildPackagesMorph

	morphs at: #packagesMorph put: ((morphs at: #window)
				newTreeFor: self
				list: #packageHierarchy
				selected: #selectedPackage
				changeSelected: #selectedPackage:).
				
	morphs 
		at: #packagesMorph 
		put: ((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph: 	(self buildControlButtons: {
					'Add' -> #packageAdd.
					'Edit' -> #packageEdit.
					'Remove' -> #packageRemove.
					'Load' -> #packageLoad.
				} asOrderedCollection);
				addMorph: (morphs at: #packagesMorph)).
	
	^ (self buildRowWithImage: 'package.png' andLabel: 'Packages' ) -> (morphs at: #packagesMorph) 
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 6/28/2012 14:16'!
buildProcessMorph
	^  (self buildRowWithImage: 'process.png' andLabel: 'Processes' )
		->
			((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph:
						((morphs at: #window)
								newTabGroup:
									{('Stack'
										->
											((morphs at: #window)
												newListFor: self
												list: #stackForProcess
												selected: nil
												changeSelected: nil
												help: nil))});
				addMorph:
						((morphs at: #window)
								newListFor: self
								list: #allProcesses
								selected: nil
								changeSelected: nil
								help: nil))! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-protocols' stamp: 'NickPapoulias 8/22/2013 14:45'!
buildProtocolsMorph

	morphs at: #protocolsMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'protocol.png' andLabel: 'Protocols') ->
				((morphs at: #window) newTreeFor: self
				list: #protocolsHierarchy
				selected: #selectedProtocol
				changeSelected: #selectedProtocol:).
		}).
		
	morphs 
		at: #protocolsMorph 
		put: ((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph: 	(self buildControlButtons: {
					'Add' -> #protocolAdd.
					'Edit' -> #protocolEdit.
					'Remove' -> #protocolRemove.
				} asOrderedCollection);
				addMorph: (morphs at: #protocolsMorph)).




	! !

!MercuryIdeEnvironmentTab methodsFor: 'utilities' stamp: 'NickPapoulias 6/28/2012 14:12'!
buildRowWithImage: anImageFilename andLabel: labelText

	 ^ (morphs at: #window) newRow: {
		(morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , anImageFilename).
		((morphs at: #window) newLabel: labelText)
	}! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-search' stamp: 'NickPapoulias 7/2/2012 10:29'!
buildSearchMorph

	morphs at: #searchMorph put: ((morphs at: #window) newLabelGroup: {
		 (self buildRowWithImage: 'search.png' andLabel: 'Search: ' ) -> 
			((morphs at: #window) newTextEntryFor: (ValueHolder new contents: '') getText: #contents setText: nil help: '')
		}).

	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-source' stamp: 'NickPapoulias 4/8/2013 17:11'!
buildSourceMorph


		morphs at: #sourceMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'source.png' andLabel: 'Code') -> self buildTextMorph.
		}).



	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 8/25/2013 12:51'!
buildTestsMorph

	^ ((morphs at: #window) newPanel 
						layoutPolicy: TableLayout new;
						listDirection: #topToBottom;
						addMorph: 	(self buildControlButtons: { 
							'Debug' -> #debugError.
						} asOrderedCollection);
						addMorph: ((morphs at: #window) newTabGroup: {'Results'-> ((morphs at: #window) newTreeFor: self list: #resultsForTests selected: nil  changeSelected: nil )});
						addMorph: 	(self buildControlButtons: { 
							'Run' -> #testRun.
							'Add' -> #testAdd.
							'Edit' -> #testEdit.
							'Remove' -> #testRemove.
						} asOrderedCollection);
						addMorph: ((morphs at: #window) newTreeFor: self list: #allTestsForClass selected: #selectedTest  changeSelected: #selectedTest:)).
						! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-source' stamp: 'NickPapoulias 4/9/2013 12:08'!
buildTextMorph


		morphs at: #textMorph put: ((((morphs at: #window) newTextEditorFor: self  getText: #sourceCode  setText: #sourceCode:)) acceptAction: [:source | self acceptSource: source]).
		"(morphs at: #textMorph) styler classOrMetaClass: self. hack so as not to style with the other side"
		^ morphs at: #textMorph.



	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 8/22/2013 14:56'!
buildToolsMorph 

	morphs at: #toolsMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'test.png' andLabel: 'Tests') -> self buildTestsMorph.
				(self buildRowWithImage: 'measurement.png' andLabel: 'Profile') ->((morphs at: #window) newPanel 
						layoutPolicy: TableLayout new;
						listDirection: #topToBottom;
						addMorph: ((morphs at: #window) newTabGroup: {'Results'-> ((morphs at: #window) newListFor: self list: #resultsForProfiling selected: nil  changeSelected: nil  help: nil)});
						addMorph: (((morphs at: #window) newPanel) 
								layoutPolicy: RowLayout new;
								addMorph: ((morphs at: #window) newTextEntryFor: (ValueHolder new contents: 'asdf') getText:  #contents setText: nil help: '');
								addMorph: ((morphs at: #window) newLabel: 'Profile: ');
								hResizing:#spaceFill)).
				(self buildRowWithImage: 'folder.png' andLabel: 'Versioning') ->((morphs at: #window) newPanel
									layoutPolicy: TableLayout new;
									listDirection: #topToBottom;
									addMorph: ((morphs at: #window ) newTabGroup: {'Repositories'-> ((morphs at: #window) newListFor: self list: #repositoriesForPackage selected: nil  changeSelected: nil  help: nil).});
									addMorph: ((morphs at: #window ) newTabGroup: {'Versions'-> ((morphs at: #window) newListFor: self list: #versionsForPackageInRepository selected: nil  changeSelected: nil  help: nil)})).
				(self buildRowWithImage: 'documentation.png' andLabel: 'Documentation') ->((morphs at: #window) newTextEntryFor: self getText: #documentationForClass setText: nil help:'').
				}).
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui' stamp: 'NickPapoulias 4/16/2013 14:11'!
buildUI

	self buildWindowMorph.
	self buildSearchMorph .
	self buildEnvironmentMorph.
	self buildClassesMorph .
	self buildProtocolsMorph .
	self buildMethodsMorph .
	self buildDebugMorph .
	self buildSourceMorph .
	self buildToolsMorph .
	self buildContextConsoleMorph .
	self buildObjInspectorMorph .
	self buildContextInspectorMorph .

	layout keys do: [:aMorphName |
			(morphs at: #window) addMorph: (morphs at: aMorphName) frame: (layout at: aMorphName).
			(morphs at: aMorphName) color: (morphs at: #window) color.	
	].

	(morphs at: #window)
			beWithoutGrips;
			removeLabelArea;
			makeBorderless.
			
	^ morphs at: #window.
! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-window' stamp: 'NickPapoulias 7/2/2012 10:38'!
buildWindowMorph

	morphs at: #window put: StandardWindow new! !

!MercuryIdeEnvironmentTab methodsFor: 'morphic-fix' stamp: 'NickPapoulias 9/14/2013 11:35'!
changed: aSelector

	thisContext receiver = self ifTrue: [self selfPerform: aSelector].
	^ super changed: aSelector.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 9/14/2013 14:09'!
classHierarchy

	(uiModel at: #selectedPackage) isNil ifFalse: [
		
		((uiModel at: #selectedPackage) metaInfo at: #isPackage) ifTrue: [
			"mirror access"
			uiModel at: #classes put: ((self allClassNamesForPackage: (uiModel at: #selectedPackage) item) collect: [:classOrTraitName |
				(MercuryTreeItem newFromAssociation: (classOrTraitName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: {} asDictionary	
			])
		
		] ifFalse: [
		
			uiModel at: #classes put: #().
		
		]
	
	] ifTrue: [
	
		uiModel at: #classes put: #().
	
	].


	uiModel at: #selectedClass put: nil.
	uiModel at: #sourceCode put: ''.
	
	^ uiModel at: #classes.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/15/2013 12:36'!
classMethodAndRangeForException: anExceptionIndex inContext: aStackIndex

	|processMirror contextMirror methodMirror classMirror className source range contextInfo |
	processMirror := (unhandledExceptions at: anExceptionIndex) interruptedProcess.
	contextMirror :=  processMirror contextAt: aStackIndex.
	contextInfo:= contextMirror description.
	contextInfo at: 6 put: ( processMirror sourceRange).
	"source := contextMirror source.
	methodMirror := contextMirror method.
	classMirror := methodMirror methodClass.
	classMirror isMeta ifTrue: [
		className := classMirror soleInstance systemName.	
	] ifFalse: [
		className := classMirror systemName.
	]."

	^ contextInfo
	"^ {classMirror package packageName . classMirror isMeta . className . methodMirror protocol . methodMirror selector . range . source}"! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 13:30'!
compileMethodWithSource: methodSource inClassNamed: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) addMethod: methodSource.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-console' stamp: 'NickPapoulias 4/12/2013 11:54'!
consoleAccept: contents

	((uiModel at: #consoleInput) = '') ifFalse: [
		|resultMirror size|
		resultMirror := self evaluateExpression: (uiModel at: #consoleInput).
		uiModel at: #consoleInput put: ''.
		uiModel at: #consoleText put: ((uiModel at: #consoleText) , Character cr asString , '>>> ' , resultMirror objAsString , Character cr , 'Workspace >>> ').
		size := (uiModel at: #consoleText) size.
		self changed: #consoleText.
		(morphs at: #console) setSelection: (Interval from: size + 1 to: size). 
		"move cursor to the end"
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-console' stamp: 'NickPapoulias 7/10/2012 13:17'!
consoleText


	^ uiModel at: #consoleText
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-console' stamp: 'NickPapoulias 7/10/2012 15:31'!
consoleText: aString
	
	|input|
	
	input := ''.
	
	(aString size <= (uiModel at: #consoleText) size) ifTrue: [
		(uiModel at: #consoleText) put: (uiModel at: #consoleText) , Character cr asString , 'Workspace >>> '. 
	] ifFalse: [	
		(uiModel at: #consoleText) size to: aString size do: [:index |
			input := input , (aString at: index) asString			
		].
		uiModel at: #consoleText put: aString.
		uiModel at: #consoleInput put: input.
	].
	! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:38'!
contextDictForException: exceptionIndex inContext: stackIndex

	|processMirror contextMirror|
	processMirror := (unhandledExceptions at: exceptionIndex) interruptedProcess.
	contextMirror :=  processMirror contextAt: stackIndex.
	^ contextMirror dictionaryForContext.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-context-inspector' stamp: 'NickPapoulias 8/27/2013 14:37'!
ctxInstr
	"the dialog should return instrumenation info"
	self instrumentationUI! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-context-inspector' stamp: 'NickPapoulias 4/19/2013 17:02'!
ctxVarNames
	
	^ (uiModel at: #ctxInspectorDict) keys asOrderedCollection addFirst: 'thisContext'; yourself ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-context-inspector' stamp: 'NickPapoulias 4/19/2013 16:59'!
ctxVarValues

	(uiModel at: #selectedCtxVar) = 0 ifTrue: [
		^ #()
	] ifFalse: [
		((uiModel) at: #selectedCtxVar) = 1 ifTrue: [
			^ {uiModel at: #thisContext} asOrderedCollection.
		] ifFalse: [
			^ {(uiModel at: #ctxInspectorDict) values at: (uiModel at: #selectedCtxVar) - 1} asOrderedCollection
		].
	].! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/25/2013 12:53'!
debugError

	(uiModel at: #selectedTest) item ifNotNil: [
		(uiModel at: #selectedClass) item ifNotNil: [
				self debugTest: (uiModel at: #selectedTest) item forClass: (uiModel at: #selectedClass) item.
		].
	].! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/9/2013 15:37'!
debugFullStack! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/9/2013 15:49'!
debugInto

	self debuggedProcess into! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/9/2013 15:49'!
debugOver

	self debuggedProcess over
	! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/4/2013 16:37'!
debugProceed

	[self debuggedProcess proceed] fork.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/9/2013 15:50'!
debugRestart

	self debuggedProcess restart! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 8/25/2013 12:53'!
debugTest: aSelector forClass: aClass

	|tClass|

	tClass := (environmentMirror globalAt: aClass) testClass.
	
	tClass ifNotNil: [^ tClass debug: aSelector] ifNil: [^ nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/9/2013 15:50'!
debugThrough

	self debuggedProcess through! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:38'!
debuggedProcess

	^ (unhandledExceptions at: ((uiModel at: #selectedException) metaInfo at: #index) ) interruptedProcess. ! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:50'!
definitionForClassNamed: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) definition! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/11/2013 12:07'!
definitionForMetaClassNamed: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) objClass definition! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 16:05'!
documentationForClass

	^ ''

! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/5/2013 13:41'!
evaluateExpression: expression

	^ environmentMirror plainEvaluate: expression! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 14:21'!
evaluateSourceCode: classCreationSource

	^ environmentMirror evaluate: classCreationSource onRemoteExceptionDo: [:anExceptionMirror | ] "should show up in the exceptions"! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 9/14/2013 15:05'!
exceptions

	"mirror access"
	|exceptions|
	exceptions := self unhandledExceptionDescriptions.
	
	uiModel at: #exceptions put: #() asOrderedCollection.
	
	exceptions doWithIndex: [:item :index |
		(uiModel at: #exceptions)
			add: ((MercuryTreeItem newFromAssociation: (item -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'exception.png')) metaInfo: {#index -> index} asDictionary) 	
	].
	

		uiModel at: #selectedException put: nil.
	
	^ uiModel at: #exceptions.! !

!MercuryIdeEnvironmentTab methodsFor: 'utilities' stamp: 'NickPapoulias 4/12/2013 14:40'!
extractSelectorFromSource: sourceCode

	^ Parser new parseSelector: sourceCode ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/24/2013 13:03'!
formatTestResult: result

	| list |
	
	list := ({(uiModel at: #selectedTest) item . '' } asOrderedCollection addAll: (result findBetweenSubStrs: ','); yourself).
	
	^ list collect: [:item |
					(MercuryTreeItem newFromAssociation: (item-> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'testResult.png')) metaInfo: {} asDictionary	
	 ].! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:37'!
fullstack

	self inDebugView & self inDebugMode ifTrue: [
		self debugFullStack
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:44'!
getAction

	^ uiModel at: #action ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:45'!
getCondition

	^ uiModel at: #condition ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:50'!
getInstrObject

	^ uiModel at: #instrObject ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 13:02'!
getInterObject

	^ uiModel at: #interObject ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:36'!
goToStackIndex: anIndexNumber

	self inDebugView & self inDebugMode ifTrue: [
		
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/9/2013 15:35'!
inDebugMode

	^  (uiModel at: #selectedException) isNil not & (uiModel at: #selectedContext) isNil not! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-exceptions' stamp: 'NickPapoulias 4/9/2013 16:25'!
inDebugView
	
	^ (morphs at: #environmentMorph) selectedTab == (morphs at: #exceptionsMorph) key owner! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-classes' stamp: 'NickPapoulias 9/14/2013 13:48'!
inMetaView



	^ ((morphs at: #classesMorph) submorphs at: 1) selectedTab == (morphs at: #metaTabMorph) key owner


	! !

!MercuryIdeEnvironmentTab methodsFor: 'initialize' stamp: 'NickPapoulias 8/24/2013 12:30'!
initialize

	morphs := Dictionary new.
	uiModel := Dictionary new.
	environmentMirror := nil.
	layout := self layout.
	uiModel := {#packages-> #() .
				#selectedPackage -> nil.
				#classes -> #().
				#selectedClass -> nil.
				#protocols -> #().
				#selectedProtocol -> nil.
				#methods -> #().
				#selectedMethod -> nil.
				#sourceCode -> '' .
				#metaSourceCode -> ''.
				#consoleText -> 'Workspace >>> '.
				#consoleInput -> '' .
				#exceptions -> #() asOrderedCollection.
				#selectedException -> nil.
				#stack -> #() asOrderedCollection.
				#selectedContext -> nil.
				#objInspectorDict-> #() asDictionary.
				#ctxInspectorDict->#() asDictionary.
				#self-> nil.
				#thisContext->nil.
				#selectedCtxVar->1.
				#selectedObjVar->1.
				#selectedTest->nil.
				#testMethods->#().
				#testResult->#()} asDictionary.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 9/1/2013 16:36'!
instrumentationUI

	| window |
	window := StandardWindow new.
	window 
		addMorph: (window 
						newLabelGroup: {
		 					(self buildRowWithImage: 'search.png' andLabel: 'Object from Expression: ' ) -> 
							(window newTextEntryFor: self getText: #getInstrObject setText: #setInstrObject: help: '')
						})frame: ((0@0 corner: 1@0.07));
		addMorph: (window newTabGroup: { 
				(self buildRowWithImage: 'class.png' andLabel: 'For Reification Category:' ) -> 
				(window 
					newTreeFor: self
					list: #reificationCategories
					selected: #selectedCategory
					changeSelected: #selectedCategory:).
			}) frame: (0@0.07 corner: 0.20@0.90);
		addMorph: (window 
						newLabelGroup: {
		 					(self buildRowWithImage: 'testResult.png' andLabel: 'Interacting With: ' ) -> 
							(window newTextEntryFor: self getText: #getInterObject setText: #setInterObject: help: '')
						})frame: ((0.23@0.07 corner: 1@0.14));
		addMorph: (window newTabGroup: { 
				(self buildRowWithImage: 'protocol.png' andLabel: 'On Condition:' ) -> 
				(window 
					newTextEditorFor: self  
					getText: #getCondition  
					setText: #setCondition:).
			}) frame: (0.26@0.17 corner: 1@0.5);
		addMorph: (window newTabGroup: { 
				(self buildRowWithImage: 'method.png' andLabel: 'With Action:' ) -> 
				(window 
					newTextEditorFor: self  
					getText: #getAction 
					setText: #setAction:).
			}) frame: (0.26@0.51 corner: 1@0.90);
		addMorph: (self buildControlButtons: {
					'Instrument' -> #launchInstrumentation. "register on the other side and proceed"
				} asOrderedCollection) frame: (0@0.92 corner: 1@1).
		
						
	window submorphs do: [:morph | morph color: (morphs at: #window) color].
	
	window
		title: 'Object Instrumentation';
		width: 1024;
		height: 768;
		openInWorld;
		position: (500 @300).! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:36'!
interuptSelectedProcess

	self inDebugView & self inDebugMode ifTrue: [
		
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 16:41'!
into

	self inDebugView & self inDebugMode ifTrue: [
		self debugInto.
		self changed: #stack.
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 9/1/2013 16:42'!
launchInstrumentation

	self 
		launchInstrumentationFor: self getInstrObject
		interactingWith: self getInterObject
		conditionedWith: self getCondition
		forCategory: self selectedCategory metaInfo
		withAction: self getAction.
	
	"Transcript 
		show: self getInstrObject; cr;
		show: self getInterObject; cr;
		show: self getCondition; cr;
		show: self getAction; cr;
		show: self selectedCategory metaInfo; cr."! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/5/2013 11:28'!
launchInstrumentationFor: expr interactingWith: interExpr conditionedWith: condExperssion forCategory: eventSelector withAction: actionCallback

	| instrumentationObjectMirror interactionObjectMirror |
	
	instrumentationObjectMirror := environmentMirror evaluate: expr in: self debuggedProcess currentContext.
	interactionObjectMirror := environmentMirror evaluate: interExpr in: self debuggedProcess currentContext.
	
	interactionObjectMirror isNil
		ifTrue: [ instrumentationObjectMirror perform: eventSelector withArguments: actionCallback ]
		ifFalse: [ 
			instrumentationObjectMirror perform: eventSelector withArguments: {actionCallback. interactionObjectMirror } 
		].
	
	"Transcript 
		show: instrumentationObjectMirror objAsString; cr;
		show: interactionObjectMirror objAsString; cr;
		show: actionCallback asString; cr."
	environmentMirror enableMetaBehaviorForRegistered.
	self proceed.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-layout' stamp: 'NickPapoulias 6/28/2012 13:10'!
layout

	^   {#searchMorph -> (0@0 corner: 1@0.04) .
		#environmentMorph -> (0@0.04 corner: 0.25@1) .
		#classesMorph -> (0.25@0.04 corner: 0.42@0.32) .
		#protocolsMorph -> (0.42@0.04 corner: 0.58@0.32) .
		#methodsMorph -> (0.58@0.04 corner: 0.75@0.32) .
		#debugMorph -> (0.25@0.32 corner: 0.75@0.38).
		#sourceMorph -> (0.25@0.38 corner: 0.75@0.80) .
		#toolsMorph -> (0.75@0.04 corner: 1@0.80) .
		#consoleMorph -> (0.25@0.80 corner: 0.70@1) .
		#sInspectorMorph -> (0.70@0.80 corner: 0.85@1).
		#cInspectorMorph -> (0.85@0.80 corner: 1@1) .} asDictionary. ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/11/2013 15:03'!
metaSourceCode

	^ uiModel at: #metaSourceCode ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/11/2013 15:04'!
metaSourceCode: aString

	uiModel at: #metaSourceCode put: aString.
	self changed: #sourceCode.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 4/11/2013 14:51'!
methodsHierarchy

	self inMetaView ifTrue: [ ^ self methodsInMeta].

	((uiModel at: #selectedClass) isNil not & (uiModel at: #selectedProtocol) isNil not) ifTrue: [
			"mirror access"
			
			((uiModel at: #selectedProtocol) item = '---all---') ifTrue: [
				uiModel at: #methods put:  (((self allMethodNamesInClass: (uiModel at: #selectedClass) item)) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary	
				]).
				uiModel at: #selectedMethod put: #(). "(uiModel at: #methods) first." "do not select method by default"	
			] ifFalse: [
			
				uiModel at: #methods put:  (((self allMethodNamesForProtocol: (uiModel at: #selectedProtocol) item inClass: (uiModel at: #selectedClass) item)) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary	
				]).
				uiModel at: #selectedMethod put: nil. "(uiModel at: #methods) first." "do not select method by default"	
			]
	] ifFalse: [
			uiModel at: #selectedMethod put: nil.
			uiModel at: #methods put: #().
	].

	(uiModel at: #selectedClass) ifNotNil: [
		uiModel at: #sourceCode put: (self definitionForClassNamed: (uiModel at: #selectedClass) item)
	] ifNil: [
		uiModel at: #sourceCode put: ''
	].

	^ uiModel at: #methods.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 4/11/2013 15:21'!
methodsInMeta

	((uiModel at: #selectedClass) isNil not & (uiModel at: #selectedProtocol) isNil not) ifTrue: [
			"mirror access"
			
			((uiModel at: #selectedProtocol) item = '---all---') ifTrue: [
				uiModel at: #methods put:  (((self allMethodNamesInMetaClass: (uiModel at: #selectedClass) item)) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary	
				]).
				uiModel at: #selectedMethod put: #(). "(uiModel at: #methods) first." "do not select method by default"	
			] ifFalse: [
			
				uiModel at: #methods put:  (((self allMethodNamesForProtocol: (uiModel at: #selectedProtocol) item inMetaClass: (uiModel at: #selectedClass) item)) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary	
				]).
				uiModel at: #selectedMethod put: nil. "(uiModel at: #methods) first." "do not select method by default"	
			]
	] ifFalse: [
			uiModel at: #selectedMethod put: nil.
			uiModel at: #methods put: #().
	].

	(uiModel at: #selectedClass) ifNotNil: [
		uiModel at: #metaSourceCode put: (self definitionForMetaClassNamed: (uiModel at: #selectedClass) item)
	] ifNil: [
		uiModel at: #metaSourceCode put: ''
	].

	^ uiModel at: #methods.! !

!MercuryIdeEnvironmentTab methodsFor: 'utilities' stamp: 'NickPapoulias 4/11/2013 14:14'!
newTabGroupIn: aThemedMorph for: labelsAndControls onTabChanged: aCallback
	"Answer a tab group morph with the given tab labels and associated pages."

	^(MercuryTabGroupMorph new
		font: UITheme current labelFont;
		cornerStyle: (UITheme current tabGroupCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		labelsAndPages: labelsAndControls)
		selectedPageIndex: (labelsAndControls isEmpty ifTrue: [0] ifFalse: [1]);
		onTabChanged: aCallback.
		! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-object-inspector' stamp: 'NickPapoulias 4/19/2013 17:02'!
objInstVarNames
	
	^ (uiModel at: #objInspectorDict) keys asOrderedCollection addFirst: 'self'; yourself 
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-object-inspector' stamp: 'NickPapoulias 4/19/2013 16:59'!
objInstVarValues

	(uiModel at: #selectedObjVar) = 0 ifTrue: [
		^ #()
	] ifFalse: [
		((uiModel) at: #selectedObjVar) = 1 ifTrue: [
			^ {uiModel at: #self} asOrderedCollection.
		] ifFalse: [
			^ {(uiModel at: #objInspectorDict) values at: (uiModel at: #selectedObjVar) - 1} asOrderedCollection
		].
	].! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-object-inspector' stamp: 'NickPapoulias 8/27/2013 14:38'!
objInstr

	self instrumentationUI ! !

!MercuryIdeEnvironmentTab methodsFor: 'open' stamp: 'NickPapoulias 9/16/2013 16:57'!
openWithEnvironmentMirror: anEnvironementMirror

	|ui|

	environmentMirror := anEnvironementMirror.
	self packageHierarchy. 
	self registerExceptionCallback.
	unhandledExceptions := anEnvironementMirror unhandledExceptions.
	self exceptions.
	ui := self buildUI.
	^ ui.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 16:43'!
over

	self inDebugView & self inDebugMode ifTrue: [
		self debugOver.
		self changed: #stack.
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/13/2013 13:17'!
packageAdd

	"todo"! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 6/29/2012 13:52'!
packageFamiliesFor: packageNames 
	
	^ (packageNames collect: [:aPackageName | (aPackageName findTokens: '-') at: 1]) asSet! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/14/2013 14:08'!
packageHierarchy

	|packageNames treeItemCollection packageFamilies|
	
	(uiModel at: #packages) isEmpty ifFalse: [^ uiModel at: #packages]. 

	packageNames := self allPackageNames. "mirror access"
	
	packageFamilies := (self packageFamiliesFor: packageNames) asOrderedCollection sort: [:a :b | a < b].

	treeItemCollection := OrderedCollection new.

	packageFamilies do: [:aPackageFamilyName |
		
		|packagesOfPackageFamily packagesAssociation|
		
		packagesOfPackageFamily := (self packagesOfPackageFamily: aPackageFamilyName in: packageNames) sort: [:a :b | a < b].
		
		packagesAssociation := (aPackageFamilyName-> (packagesOfPackageFamily collect: [:aPackageName |
			(MercuryTreeItem newFromAssociation: (aPackageName -> #()) withIcon:  (Form fromFileNamed: self resourcesDirectory , 'package.png')) metaInfo: {#isPackage -> true} asDictionary.
		])).
		
		treeItemCollection add: ((MercuryTreeItem newFromAssociation: packagesAssociation withIcon: (Form fromFileNamed: self resourcesDirectory , 'package.png')) metaInfo: {#isPackage -> false} asDictionary). 
				
	]. 

	uiModel at: #packages put: treeItemCollection.
	
	uiModel at: #selectedPackage put: nil.

	^ treeItemCollection ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/16/2013 09:08'!
packageLoad

	"todo"
	
	self showLogo.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 6/29/2012 14:00'!
packagesOfPackageFamily: aPackageFamilyName in: packageNames

	^ packageNames select: [:packageName | (packageName size >= aPackageFamilyName size) ifTrue: [ ((packageName copyFrom: 1 to: (aPackageFamilyName size)) = aPackageFamilyName)] ifFalse: [ false ] ].! !

!MercuryIdeEnvironmentTab methodsFor: 'morphic-fix' stamp: 'NickPapoulias 9/14/2013 14:00'!
perform: aSymbol 

	"refactor to a dedicated class the uiModel"
	
	aSymbol = #packageHierarchy ifTrue: [^ uiModel at: #packages].
	aSymbol = #classHierarchy ifTrue: [^ uiModel at: #classes].
	aSymbol = #protocolsHierarchy ifTrue: [^ uiModel at: #protocols].
	aSymbol = #methodsHierarchy ifTrue: [^ uiModel at: #methods].
	aSymbol = #allTestsForClass ifTrue: [^ uiModel at: #testMethods].
	aSymbol = #resultsForTests ifTrue: [^ uiModel at: #testResult].
	aSymbol = #sourceCode ifTrue: [
		self inMetaView ifTrue: [^ self metaSourceCode] ifFalse: [ ^ uiModel at: aSymbol]
	].
	(uiModel keys includes: aSymbol) ifTrue: [^ uiModel at: aSymbol].
	^ self selfPerform: aSymbol.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 9/4/2013 16:41'!
proceed

	self inDebugView & self inDebugMode ifTrue: [
		self debugProceed.
		(Delay forSeconds: 2) wait.
		uiModel at: #selectedException put: nil.
		self changed: #exceptions.
		self changed: #stack.
		self changed: #ctxVarNames.
		self changed: #objInstVarNames.
		self changed: #objInstVarValues.
		self changed: #ctxVarValues.		
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 4/11/2013 14:50'!
protocolsHierarchy

	self inMetaView ifTrue: [^ self protocolsInMeta].

	((uiModel at: #selectedClass)) isNil ifFalse: [
			"mirror access"
			uiModel at: #protocols put: ((self allProtocolNamesForClass: (uiModel at: #selectedClass) item) collect: [:protocolName |
				(MercuryTreeItem newFromAssociation: (protocolName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')) metaInfo: {} asDictionary	
			]).
			(uiModel at: #protocols) addFirst: (MercuryTreeItem newFromAssociation: ('---all---' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')).	
	] ifTrue: [
		
			uiModel at: #protocols put: #() asOrderedCollection 
		
	].

	uiModel at: #selectedProtocol put: nil.
	
	^ uiModel at: #protocols.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 4/11/2013 14:50'!
protocolsInMeta

	((uiModel at: #selectedClass)) isNil ifFalse: [
			"mirror access"
			uiModel at: #protocols put: ((self allProtocolNamesForMetaClass: (uiModel at: #selectedClass) item) collect: [:protocolName |
				(MercuryTreeItem newFromAssociation: (protocolName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')) metaInfo: {} asDictionary	
			]).
			(uiModel at: #protocols) addFirst: (MercuryTreeItem newFromAssociation: ('---all---' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')).	
	] ifTrue: [
		
			uiModel at: #protocols put: #() asOrderedCollection 
		
	].

	uiModel at: #selectedProtocol put: nil.
	
	^ uiModel at: #protocols.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:38'!
receiverDictForException: exceptionIndex  inContext: stackIndex

	|processMirror contextMirror|
	processMirror := (unhandledExceptions at: exceptionIndex) interruptedProcess.
	contextMirror :=  processMirror contextAt: stackIndex.
	^ contextMirror dictionaryForReceiver.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:38'!
recompileCurrentMethodTo: sourceCode

	|debuggingSource|
	
	debuggingSource := self 
				classMethodAndRangeForException: ((uiModel at: #selectedException) metaInfo at: #index) 
				inContext: ((uiModel at: #selectedContext) metaInfo at: #index).
				
	((debuggingSource at: 3) = (uiModel at: #selectedClass) item) & 
	((debuggingSource at: 5) = (self extractSelectorFromSource: sourceCode)) ifTrue: [
		|processMirror|
		processMirror := ((unhandledExceptions) at: ((uiModel at: #selectedException) metaInfo at: #index)) interruptedProcess.
		processMirror recompileCurrentMethod: sourceCode.
		self changed: #stack.
	] ifFalse: [
		self acceptSourceForBrowser: sourceCode.
	]
	! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:37'!
registerExceptionCallback 

	environmentMirror onRemoteExceptionDo: [:remoteEx | unhandledExceptions := environmentMirror unhandledExceptions. self changed: #exceptions. self switchToDebugView.].! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 9/1/2013 16:31'!
reificationCategories

	^	{
			(MercuryTreeItem newFromAssociation: ('Field Read' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onClassRead:.
			(MercuryTreeItem newFromAssociation: ('Field Write' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onClassWrite:.
			(MercuryTreeItem newFromAssociation: ('Object Read' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onRead:.
			(MercuryTreeItem newFromAssociation: ('Object Write' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onWrite:.
			(MercuryTreeItem newFromAssociation: ('Object Send' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onSend:.
			(MercuryTreeItem newFromAssociation: ('Object Receive' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onReceive:.
			(MercuryTreeItem newFromAssociation: ('Object as Argument' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onArgument:.
			(MercuryTreeItem newFromAssociation: ('Object Creation' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onCreation:.
			(MercuryTreeItem newFromAssociation: ('Object Interaction' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onInteraction:with:.
			(MercuryTreeItem newFromAssociation: ('Object Store' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: #onStore:.
		}	asOrderedCollection 
			

! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 16:05'!
repositoriesForPackage

	^ #()

! !

!MercuryIdeEnvironmentTab methodsFor: 'resources' stamp: 'NickPapoulias 6/19/2013 11:13'!
resourcesDirectory

	^ PlatformResolver forCurrentPlatform home parent parent asString , '/MercuryIDE_resources/'! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 16:43'!
restart

	self inDebugView & self inDebugMode ifTrue: [
		self debugRestart.
		self changed: #stack.
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 14:52'!
resultsForProfiling

	^ #()

! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/24/2013 12:30'!
resultsForTests

	^ uiModel at: #testResult ifAbsent: [#()]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:37'!
runDebug: aString

	self inDebugView & self inDebugMode ifTrue: [
		
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 8/24/2013 12:18'!
runTest: aSelector forClass: aClass

	|tClass|

	tClass := (environmentMirror globalAt: aClass) testClass.
	
	tClass ifNotNil: [^ tClass run: aSelector] ifNil: [^ nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:37'!
runToHere: anIntervalAsString

	self inDebugView & self inDebugMode ifTrue: [
		
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/12/2013 15:34'!
selectClass: aClassName

	|targetTreeItem|

	(uiModel at: #classes) do: [:treeItem | 
			(treeItem item = aClassName) ifTrue: [
				targetTreeItem := treeItem.		
			]	
	]. 

	targetTreeItem ifNotNil: [
		uiModel at: #selectedClass put: targetTreeItem .
	uiModel at: #sourceCode put: (self definitionForClassNamed: (uiModel at: #selectedClass) item).
	uiModel at: #metaSourceCode put: (self definitionForMetaClassNamed: (uiModel at: #selectedClass) item).
	uiModel at: #selectedTest put: nil.
	uiModel at: #testMethods put: #().
	self changed: #selectedClass.
	self changed: #protocolsHierarchy.

	].	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 4/11/2013 15:58'!
selectMetaClass: aClassName

	self switchToMeta.
	self selectClass: aClassName.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/12/2013 15:37'!
selectMethod: aMethodName

	|targetTreeItem|

	(uiModel at: #methods) do: [:treeItem | 
			(treeItem item = aMethodName) ifTrue: [
				targetTreeItem := treeItem.		
			]	
	]. 

	targetTreeItem ifNotNil: [


		uiModel at: #selectedMethod put: targetTreeItem.
		self changed: #selectedMethod.
	].		! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/12/2013 15:33'!
selectPackage: aPackageName

	|targetTreeItem|

	(uiModel at: #packages) do: [:treeItem | 
		(treeItem metaInfo at: #isPackage) ifTrue: [
			(treeItem item = aPackageName) ifTrue: [
				targetTreeItem := treeItem.		
			]	
		] ifFalse: [
			treeItem contents do: [:tItem | 
				(tItem item = aPackageName) ifTrue: [
					targetTreeItem := tItem.		
				]
			]
		]
	].

	targetTreeItem ifNotNil: [
		uiModel at: #selectedPackage put: targetTreeItem.
		self changed: #selectedPackage.
		self changed: #classHierarchy.
	].! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/12/2013 15:35'!
selectProtocol: aProtocolName

	|targetTreeItem|

	(uiModel at: #protocols) do: [:treeItem | 
			(treeItem item = aProtocolName) ifTrue: [
				targetTreeItem := treeItem.		
			]	
	]. 

	targetTreeItem ifNotNil: [
		uiModel at: #selectedProtocol put: targetTreeItem.
		self changed: #selectedProtocol.
		self changed: #methodsHierarchy.
	].	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:20'!
selectedCategory

	^ uiModel at: #selectedCategory ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:22'!
selectedCategory: aTreeItem

	uiModel at: #selectedCategory put: aTreeItem.
	self changed: #selectedCategory.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 7/3/2012 13:05'!
selectedClass

	^ uiModel at: #selectedClass ifAbsent: [nil]
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 9/14/2013 14:17'!
selectedClass: aClassItem

	uiModel at: #selectedClass put: aClassItem.
	uiModel at: #sourceCode put: (self definitionForClassNamed: (uiModel at: #selectedClass) item).
	uiModel at: #metaSourceCode put: (self definitionForMetaClassNamed: (uiModel at: #selectedClass) item).
	uiModel at: #selectedTest put: nil.
	uiModel at: #testMethods put: #().
	self changed: #selectedClass.
	self changed: #protocolsHierarchy.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.
	self changed: #allTestsForClass.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 11:56'!
selectedContext

	^ uiModel at: #selectedContext ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 9/14/2013 15:51'!
selectedContext: anItem

	|source exceptionIndex stackIndex|

	uiModel at: #selectedContext put: anItem.
	exceptionIndex := ((uiModel at: #selectedException) metaInfo at: #index) .
	stackIndex := ((uiModel at: #selectedContext) metaInfo at: #index).
	source := self 
				classMethodAndRangeForException: exceptionIndex 
				inContext: stackIndex.
	self changed: #selectedContext. 
	"self selectPackage: (source at: 1). "
	(source at: 2) ifFalse: [ self switchToBase. self singleSelectClass: (source at: 3) ] ifTrue: [self switchToMeta. self singleSelectClass: (source at: 3)].
	self singleSelectProtocol: (source at: 4).
	self singleSelectMethod: (source at: 5).
	(source at: 2) ifFalse: [ self sourceCode: (source at: 7) ] 
				    ifTrue: [ self metaSourceCode: (source at: 7)].
	self sourceSelection: (source at: 6).
	uiModel at: #objInspectorDict put: (self receiverDictForException: exceptionIndex  inContext: stackIndex).
	uiModel at: #ctxInspectorDict put: (self contextDictForException: exceptionIndex inContext: stackIndex).
	uiModel at: #self put: ((uiModel at: #objInspectorDict) removeKey: #self).
	uiModel at: #thisContext put: ((uiModel at: #ctxInspectorDict) removeKey: #thisContext).
	(uiModel at: #selectedCtxVar) > (uiModel at: #ctxInspectorDict) size ifTrue: [uiModel at: #selectedCtxVar put: 1].
	(uiModel at: #selectedObjVar) > (uiModel at: #objInspectorDict) size ifTrue: [uiModel at: #selectedObjVar put: 1].
	self selectedCtxVar: (uiModel at: #selectedCtxVar).
	self selectedObjVar: (uiModel at: #selectedObjVar).
	"self changed: #objInstVarNames.
	self changed: #objInstVarValues.
	self changed: #ctxVarNames.
	self changed: #ctxVarValues.
	"! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-context-inspector' stamp: 'NickPapoulias 4/19/2013 15:26'!
selectedCtxVar

	^ uiModel at: #selectedCtxVar ifAbsent: [0]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-context-inspector' stamp: 'NickPapoulias 4/24/2013 12:09'!
selectedCtxVar: aVarName

	uiModel at: #selectedCtxVar put: aVarName.
	self changed: #selectedCtxVar.
	self changed: #ctxVarValues.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/23/2013 14:27'!
selectedException

	^ uiModel at: #selectedException ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 11:55'!
selectedException: anItem

	uiModel at: #selectedException put: anItem.
	self changed: #selectedException.
	self changed: #stack.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 7/2/2012 16:52'!
selectedMethod

	^ uiModel at: #selectedMethod ifAbsent: [nil]
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 4/11/2013 15:39'!
selectedMethod: aMethodItem

	self inMetaView ifTrue: [^ self selectedMethodInMeta: aMethodItem].

	uiModel at: #selectedMethod put: aMethodItem.
	uiModel at: #sourceCode put: (self sourceCodeForMethodNamed: aMethodItem item inClassNamed: (uiModel at: #selectedClass) item).
	self changed: #selectedMethod.
	self changed: #sourceCode.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 4/11/2013 15:39'!
selectedMethodInMeta: aMethodItem

	uiModel at: #selectedMethod put: aMethodItem.
	uiModel at: #metaSourceCode put: (self sourceCodeForMethodNamed: aMethodItem item inMetaClassNamed: (uiModel at: #selectedClass) item).
	self changed: #selectedMethod.
	self changed: #sourceCode.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-object-inspector' stamp: 'NickPapoulias 4/19/2013 15:19'!
selectedObjVar

	^ uiModel at: #selectedObjVar ifAbsent: [0]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-object-inspector' stamp: 'NickPapoulias 4/19/2013 15:23'!
selectedObjVar: aVarIndex

	uiModel at: #selectedObjVar put: aVarIndex.
	self changed: #selectedObjVar.
	self changed: #objInstVarValues.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 7/3/2012 13:04'!
selectedPackage

	^ uiModel at: #selectedPackage ifAbsent: [ nil]
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 7/3/2012 11:44'!
selectedPackage: aPackageItem

	uiModel at: #selectedPackage put: aPackageItem.
	self changed: #selectedPackage.
	self changed: #classHierarchy.
	self changed: #protocolsHierarchy.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.
	"(morphs at: #classesListingMorph) update: #classHierarchy."! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 7/3/2012 13:05'!
selectedProtocol

	^ uiModel at: #selectedProtocol ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 7/3/2012 13:06'!
selectedProtocol: aProtocolItem

	uiModel at: #selectedProtocol put: aProtocolItem.
	self changed: #selectedProtocol.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/20/2013 15:25'!
selectedTest

	^ uiModel at: #selectedTest ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/20/2013 16:32'!
selectedTest: aTestItem

	uiModel at: #selectedTest put: aTestItem.
	self changed: #selectedTest.! !

!MercuryIdeEnvironmentTab methodsFor: 'morphic-fix' stamp: 'NickPapoulias 9/14/2013 11:48'!
selfPerform: aSymbol 
	"Transcript show: aSymbol; cr."
	^ super perform: aSymbol.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:45'!
setAction: text

	uiModel at: #action put: text.
	self changed: #getAction.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 9/1/2013 16:38'!
setCondition: text

	uiModel at: #condition put: text.
	self changed: #getCondition.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 12:50'!
setInstrObject: text

	uiModel at: #instrObject put: text.
	self changed: #getInstrObject.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-instrumentation-dialog' stamp: 'NickPapoulias 8/28/2013 13:02'!
setInterObject: text

	uiModel at: #interObject put: text.
	self changed: #getInterObject.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-source' stamp: 'NickPapoulias 4/9/2013 12:11'!
shoutAboutToStyle: aPluggableShoutMorphOrView 

	^ false



	! !

!MercuryIdeEnvironmentTab methodsFor: 'utilities' stamp: 'NickPapoulias 9/13/2013 13:10'!
showLogo

	| logo displayPoint |
	logo := (Form fromFileNamed: self resourcesDirectory , 'alexandria-logo.png').
	displayPoint := Point
					x: Display center x - (logo width / 2) asInteger
					y: Display center y - (logo height / 2) asInteger.
	[(Delay forSeconds: 1) wait.
	logo displayOn: Display at: displayPoint.
	(Delay forSeconds: 5) wait.
	Display restore.] fork.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/14/2013 15:53'!
singleSelectClass: aClassName

	uiModel at: #classes put: {((MercuryTreeItem newFromAssociation: (aClassName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: {} asDictionary)} asOrderedCollection.
	super changed: #classHierarchy.
		! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/14/2013 15:54'!
singleSelectMethod: aMethodName

	uiModel at: #methods put: {((MercuryTreeItem newFromAssociation: (aMethodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary)} asOrderedCollection.
	super changed: #methodsHierarchy.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 9/14/2013 15:56'!
singleSelectProtocol: aProtocolName

	uiModel at: #protocols put: {((MercuryTreeItem newFromAssociation: (aProtocolName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')) metaInfo: {} asDictionary)} asOrderedCollection.
	super changed: #protocolsHierarchy! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 9/14/2013 14:05'!
sourceCode


	self inMetaView ifTrue: [^ self metaSourceCode].

	^ uiModel at: #sourceCode ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/11/2013 15:04'!
sourceCode: aString

	self inMetaView ifTrue: [ ^ self metaSourceCode: aString].

	uiModel at: #sourceCode put: aString.
	self changed: #sourceCode.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 12:07'!
sourceCodeForMethodNamed: aMethodName inClassNamed: aClassName

	^ ((environmentMirror globalAt: aClassName) methodAt: aMethodName asSymbol) source 
! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/11/2013 15:39'!
sourceCodeForMethodNamed: aMethodName inMetaClassNamed: aClassName

	^ ((environmentMirror globalAt: aClassName) objClass methodAt: aMethodName asSymbol) source 
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/12/2013 11:52'!
sourceSelection: interval 

	"Transcript show: interval xxx__asString."

	(morphs at: #textMorph) setSelection: interval.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 9/14/2013 14:12'!
stack

	(uiModel at: #selectedException) isNil ifFalse: [
		
		|stack index|
		uiModel at: #stack put: #() asOrderedCollection.
		index := self stackIndexForException: (((uiModel at: #selectedException)) metaInfo at: #index).
		stack := self stackForException: (((uiModel at: #selectedException)) metaInfo at: #index).
	
		stack doWithIndex: [:item :anIndex |
			(uiModel at: #stack)
				add: ((MercuryTreeItem newFromAssociation: (item -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {#index -> anIndex} asDictionary) 	
		].
	
		(index ~= 0) ifTrue: [
			self selectedContext: ((uiModel at: #stack) at: index).
		] ifFalse: [
			uiModel at: #selectedContext put: nil.
		].
		
	] ifTrue: [
	
		uiModel at: #stack put: #().
		uiModel at: #objInspectorDict put: #() asDictionary.
		uiModel at:	#ctxInspectorDict put: #() asDictionary.
		uiModel at: #selectedCtxVar put: 1.
		uiModel at: #selectedObjVar put: 1.
		uiModel at:	#self put: nil.
		uiModel at:	#thisContext put: nil.
	
	].
	
	^ uiModel at: #stack.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:52'!
stackForException: anIndex

	^ (unhandledExceptions at: anIndex) interruptedProcess stackDescription! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 6/21/2012 13:13'!
stackForProcess

	^ #()! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 14:39'!
stackIndexForException: anIndex

	^ (unhandledExceptions at: anIndex) interruptedProcess currentContextIndex.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:37'!
stopSelectedProcess

	self inDebugView & self inDebugMode ifTrue: [
		
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-classes' stamp: 'NickPapoulias 9/12/2013 15:44'!
switchToBase

	self inMetaView ifTrue: [
		(morphs at: #classesMorph) submorphs first selectedPageIndex: 1
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-debug' stamp: 'NickPapoulias 4/24/2013 12:22'!
switchToDebugView

		(morphs at: #environmentMorph) selectedPageIndex: 3! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-classes' stamp: 'NickPapoulias 9/12/2013 15:01'!
switchToMeta

	self inMetaView ifFalse: [
		(morphs at: #classesMorph) submorphs first selectedPageIndex: 2
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 9/6/2013 15:58'!
testAdd

	| testMethod selector currentClass tClass className|
	testMethod := (UITheme builder openModal: (TextEditorDialogWindow new
			textFont: StandardFonts defaultFont;
			title: 'Add a new Test';
			entryHeight: 200;
			text: 'Test Method: ';
			entryText: '')) entryText.
			
	testMethod = nil ifTrue: [^ nil].
	
	className := (uiModel at: #selectedClass) item.
	currentClass := (environmentMirror globalAt: className).
	tClass := currentClass testClass.
	
	tClass ifNil: [
	
			currentClass package newClassNamed: className, 'Test' inheritingFrom: 'TestCase'.
			tClass := (environmentMirror globalAt: className) testClass.		
	].
	
	selector := self compileMethodWithSource: testMethod inClassNamed: className , 'Test'.
	
	self changed: #allTestsForClass.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-tools' stamp: 'NickPapoulias 8/24/2013 12:48'!
testRun


	 | result |
	(uiModel at: #selectedTest) item ifNotNil: [
		(uiModel at: #selectedClass) item ifNotNil: [
				result := self runTest: (uiModel at: #selectedTest) item forClass: (uiModel at: #selectedClass) item.
				result ifNotNil: [
					uiModel at: #testResult put: (self formatTestResult: result).
					self changed: #resultsForTests.
				].
		].
	].! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 16:44'!
through

	self inDebugView & self inDebugMode ifTrue: [
		self debugThrough.
		self changed: #stack.
	] ! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 9/14/2013 15:06'!
unhandledExceptionDescriptions

	^ environmentMirror unhandledExceptionsDescriptions! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 16:04'!
versionsForPackageInRepository

	^ #()

! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 4/9/2013 15:37'!
where

	self inDebugView & self inDebugMode ifTrue: [
		
	] ! !
